#include <iostream>
using namespace std;

struct point
{
       int x, y;
};

struct vector
{
       int x, y;
       vector operator+( const vector &v )
       {
              vector r;
              r.x = x + v.x;
              r.y = y + v.y;
              return r;
       }
};

int scalp( vector a, vector b )
{
    return a.x * b.x + a.y * b.y;
}

int vectp( vector a, vector b )
{
    return a.x * b.y - b.x * a.y;
}

vector P2V( point a, point b )
{
       vector r;
       r.x = b.x - a.x;
       r.y = b.y - a.y;
       return r;
}

int n;
point O, A, B, C, X, a[1024];
vector OA, OB, OC, AO, BO, BC, AC, CB, AB, BA, OX, AX, BX, CX, CA, CO;

int main()
{
    int i, br = 0, k, nu;
    cin >> A.x >> A.y >> B.x >> B.y >> n;
    O.x = 0;
    O.y = 0;
    for ( i = 1; i <= n; i++ )
        cin >> a[i].x >> a[i].y;
    OA = P2V( O, A );
    OB = P2V( O, B );
    AO = P2V( A, O );
    BO = P2V( B, O );
    AB = P2V( A, B );
    BA = P2V( B, A );
    if ( scalp( OA, OB ) == 0 )
    {
         OC = OA + OB;
         C.x = OC.x;
         C.y = OC.y;
         CA = P2V( C, A );
         BC = P2V( B, C );
         AC = P2V( A, C );
         CB = P2V( C, B );
         for ( i = 1; i <= n; i++ )
         {
             k = 0;
             nu = 0;
             X = a[i];
             OX = P2V( O, X );
             CX = P2V( C, X );
             BX = P2V( B, X );
             AX = P2V( A, X );
             if ( vectp( OB, OA ) > 0 )
             {
                if ( vectp( OX, OB ) > 0 )
                   k++;
                else if ( vectp( OX, OB ) < 0 )
                     k--;
                else nu++;
                if ( vectp( BX, BC ) > 0 )
                   k++;
                else if ( vectp( BX, BC ) < 0 )
                     k--;
                else nu++;
                if ( vectp( CX, CA ) > 0 )
                    k++;
                else if ( vectp( CX, CA ) < 0 )
                    k--;
                else nu++;
                if ( vectp( AX, AO ) > 0 )
                   k++;
                else if ( vectp( AX, AO ) < 0 )
                   k--;
                else nu++;
             }
             else
             {
                if ( vectp( OX, OA ) > 0 )
                   k++;
                else if ( vectp( OX, OA ) < 0 )
                     k--;
                else nu++;
                if ( vectp( AX, AC ) > 0 )
                   k++;
                else if ( vectp( AX, AC ) < 0 )
                     k--;
                else nu++;
                if ( vectp( CX, CB ) > 0 )
                    k++;
                else if ( vectp( CX, CB ) < 0 )
                    k--;
                else nu++;
                if ( vectp( BX, BO ) > 0 )
                   k++;
                else if ( vectp( BX, BO ) < 0 )
                   k--;
                else nu++;
             }
             if ( abs( k ) + nu == 4 )
             {
                br++;
             }
         }
    }
    else if ( scalp( OA, OB ) > 0 )
    {
         if ( scalp( AB, AO ) == 0 )
         {
              OC = OB + AO;
         }
         else if ( scalp( BA, BO ) == 0 )
         {
              OC = OA + BO;
         }
         C.x = OC.x;
         C.y = OC.y;
         CA = P2V( C, A );
         BC = P2V( B, C );
         AC = P2V( A, C );
         CB = P2V( C, B );
         CO = P2V( C, O );
         if ( ( vectp( OA, OB ) > 0 ) && ( vectp( OB, OC ) > 0 ) )
            for ( i = 1; i <= n; i++ )
            {
                k = 0;
                nu = 0;
                X = a[i];
                OX = P2V( O, X );
                BX = P2V( B, X );
                AX = P2V( A, X );
                if ( vectp( OX, OA ) > 0 )
                   k++;
                else if ( vectp( OX, OA ) < 0 )
                     k--;
                else nu++;
                if ( vectp( AX, AB ) > 0 )
                   k++;
                else if ( vectp( AX, AB ) < 0 )
                     k--;
                else nu++;
                if ( vectp( BX, BC ) > 0 )
                    k++;
                else if ( vectp( BX, BC ) < 0 )
                    k--;
                else nu++;
                if ( vectp( CX, CO ) > 0 )
                   k++;
                else if ( vectp( CX, CO ) < 0 )
                   k--;
                else nu++;
                if ( abs( k ) + nu == 4 )
                    br++;
            }
         else if ( ( vectp( OC, OA ) > 0 ) && ( vectp( OA, OB ) > 0 ) )
            for ( i = 1; i <= n; i++ )
            {
                k = 0;
                nu = 0;
                X = a[i];
                OX = P2V( O, X );
                BX = P2V( B, X );
                AX = P2V( A, X );
                if ( vectp( OX, OC ) > 0 )
                   k++;
                else if ( vectp( OX, OC ) < 0 )
                     k--;
                else nu++;
                if ( vectp( CX, CA ) > 0 )
                   k++;
                else if ( vectp( CX, CA ) < 0 )
                     k--;
                else nu++;
                if ( vectp( AX, AB ) > 0 )
                    k++;
                else if ( vectp( AX, AB ) < 0 )
                    k--;
                else nu++;
                if ( vectp( BX, BO ) > 0 )
                   k++;
                else if ( vectp( BX, BO ) < 0 )
                   k--;
                else nu++;
                if ( abs( k ) + nu == 4 )
                    br++;
            }
         else if ( ( vectp( OC, OB ) > 0 ) && ( vectp( OB, OA ) > 0 ) )
            for ( i = 1; i <= n; i++ )
            {
                k = 0;
                nu = 0;
                X = a[i];
                OX = P2V( O, X );
                BX = P2V( B, X );
                AX = P2V( A, X );
                if ( vectp( OX, OC ) > 0 )
                   k++;
                else if ( vectp( OX, OC ) < 0 )
                     k--;
                else nu++;
                if ( vectp( CX, CB ) > 0 )
                   k++;
                else if ( vectp( CX, CB ) < 0 )
                     k--;
                else nu++;
                if ( vectp( BX, BA ) > 0 )
                    k++;
                else if ( vectp( BX, BA ) < 0 )
                    k--;
                else nu++;
                if ( vectp( AX, AO ) > 0 )
                   k++;
                else if ( vectp( AX, AO ) < 0 )
                   k--;
                else nu++;
                if ( abs( k ) + nu == 4 )
                    br++;
            }
         else if ( ( vectp( OB, OA ) > 0 ) && ( vectp( OA, OC ) > 0 ) )
            for ( i = 1; i <= n; i++ )
            {
                k = 0;
                nu = 0;
                X = a[i];
                OX = P2V( O, X );
                BX = P2V( B, X );
                AX = P2V( A, X );
                if ( vectp( OX, OB ) > 0 )
                   k++;
                else if ( vectp( OX, OB ) < 0 )
                     k--;
                else nu++;
                if ( vectp( BX, BA ) > 0 )
                   k++;
                else if ( vectp( BX, BA ) < 0 )
                     k--;
                else nu++;
                if ( vectp( AX, AC ) > 0 )
                    k++;
                else if ( vectp( AX, AC ) < 0 )
                    k--;
                else nu++;
                if ( vectp( CX, CO ) > 0 )
                   k++;
                else if ( vectp( CX, CO ) < 0 )
                   k--;
                else nu++;
                if ( abs( k ) + nu == 4 )
                    br++;
             }
    }
    cout << br << endl;
    return 0;
}
